﻿using System;

namespace WpfModel.Validation
{
  public abstract class ValidationStatesBase
  {
    private ObjectState _state;
    public ObjectState State
    {
      get
      {
        return _state;
      }
      protected set
      {
        //if (_state != value)
        {
          _state = value;
          OnStateChanged();
        }
      }
    }
    public event EventHandler<EventArgs> StateChanged;

    private void OnStateChanged()
    {
      if (StateChanged != null)
      {
        StateChanged(this, EventArgs.Empty);
      }
    }
  }
}