﻿using System;
using System.Collections;
using System.Linq;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Input;
using System.Windows.Shapes;

namespace WpfView
{
  /// <summary>
  /// Interaction logic for MainView.xaml
  /// </summary>
  public partial class MainView : Page
  {
    public static readonly DependencyProperty DataProperty = DependencyProperty.Register("Data", typeof(Object), typeof(MainView), 
      new PropertyMetadata(null, OnDataChanged, OnDataCoerce));

    private static void OnDataChanged(DependencyObject d, DependencyPropertyChangedEventArgs e)
    {
      var mainView = (MainView) d;
      mainView.OnDataChanged(e.OldValue, e.NewValue);
    }

    protected virtual void OnDataChanged(object oldValue, object newValue)
    {
    }

    private static object OnDataCoerce(DependencyObject d, object basevalue)
    {
      if (basevalue is Int32)
      {
        return null;
      }
      return basevalue;
    }

    public IEnumerable Data
    {
      get
      {
        return (IEnumerable)GetValue(DataProperty);
      }
      set
      {
        SetValue(DataProperty, value);
      }
    
    }

    public MainView()
    {
      InitializeComponent();

      CommandBindings.Add(new CommandBinding(ApplicationCommands.Close, (sender, args) => Application.Current.Shutdown()));
      InputBindings.Add(new KeyBinding(ApplicationCommands.Close, Key.X, ModifierKeys.Control));
    }

    private void NotACommand_OnExecuted(object sender, ExecutedRoutedEventArgs e)
    {
      var ellipse = VisualElementHelper.FindVisualChildren<Ellipse>(sender as DependencyObject);
      var message = ellipse.Any() ? "Ugly button was clicked" : "Classic button was clicked";

      MessageBox.Show(message, "Incredible");      
    }
  }
}
